<template>
  <section id="main" v-on:keydown="keyboardDown($event)" v-on:keyup="keyboardUp($event)" tabindex="0">
    <div class="nowplaying"></div>
    <div class="keys">
      <!-- <div v-for="(item, index) in keys" :key="index" :data-key="item.key" class="key" :data-note="item.note">
        <span class="hints">{{index}}</span>
      </div> -->
      <div data-key="65" class="key" >
        <span class="hints">Q</span>
      </div>
      <div data-key="87" class="key sharp">
        <span class="hints">Z</span>
      </div>
      <div data-key="83" class="key" >
        <span class="hints">S</span>
      </div>
      <div data-key="69" class="key sharp">
        <span class="hints">E</span>
      </div>
      <div data-key="68" class="key" >
        <span class="hints">D</span>
      </div>
      <div data-key="70" class="key" >
        <span class="hints">F</span>
      </div>
      <div data-key="84" class="key sharp">
        <span class="hints">T</span>
      </div>
      <div data-key="71" class="key" >
        <span class="hints">G</span>
      </div>
      <div data-key="89" class="key sharp">
        <span class="hints">Y</span>
      </div>
      <div data-key="72" class="key" >
        <span class="hints">H</span>
      </div>
      <div data-key="85" class="key sharp">
        <span class="hints">U</span>
      </div>
      <div data-key="74" class="key">
        <span class="hints">J</span>
      </div>
      <div data-key="75" class="key">
        <span class="hints">K</span>
      </div>
      <div data-key="79" class="key sharp">
        <span class="hints">O</span>
      </div>
      <div data-key="76" class="key" >
        <span class="hints">L</span>
      </div>
      <div data-key="80" class="key sharp">
        <span class="hints">P</span>
      </div>
      <div data-key="186" class="key" >
        <span class="hints">M</span>
      </div>
    </div>
  </section>
</template>

<script>
import Tone from "tone";
    const synth = new Tone.PolySynth(3, Tone.Synth).toMaster()
    
export default {
  name: "HelloWorld",
  props: {
    msg: String
  },
  data() {
    return {
      keys: {
        q: { note: "C4"},
        z: { note: "C#4"},
        s: { note: "D4"},
        e: { note: "D#4"},
        d: { note: "E4"},
        f: { note: "F4"},
        t: { note: "F#4"},
        g: { note: "G4"},
        y: { note: "G#4"},
        h: { note: "A4"},
        u: { note: "A#4"},
        j: { note: "B4"},
        k: { note: "C5"},
        o: { note: "C#5"},
        l: { note: "D5"},
        p: { note: "D#5"},
        m: { note: "E5"},
      }
    };
  },
  mounted() {},
  methods: {
    playNote(note) {
      
      synth.triggerAttackRelease(note, 1)
    },
    keyboardDown(event) {

      if (!this.keys[event.key].playing) {
        this.keys[event.key].playing = true;
        synth.triggerAttack(this.keys[event.key].note);
      }
    },

    keyboardUp(event) {
      
      if (this.keys[event.key].playing) {
        this.keys[event.key].playing = false;

        synth.triggerRelease(this.keys[event.key].note);
      }
    }
  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}

v-btn {
  background: #308bb97c;
  border-color: rgba(49, 141, 186, 0.5);
  color: rgba(49, 141, 186, 0.5);

  height: 30px;
}

html {
  background: #000;
  font-family: "Noto Serif", serif;
  -webkit-font-smoothing: antialiased;
  text-align: center;
}

video#bgvid {
  position: fixed;
  top: 50%;
  left: 50%;
  min-width: 100%;
  min-height: 100%;
  width: auto;
  height: auto;
  z-index: -100;
  transform: translateX(-50%) translateY(-50%);
  background-size: cover;
}

header {
  position: relative;
  margin: 30px 0;
}

header:after {
  content: "";
  width: 460px;
  height: 15px;
  display: inline-block;
  text-align: center;
  background-size: 70%;
}

h1 {
  color: #fff;
  font-size: 50px;
  font-weight: 400;
  letter-spacing: 0.18em;
  text-transform: uppercase;
  margin: 0;
}

h2 {
  color: #fff;
  font-size: 24px;
  font-style: italic;
  font-weight: 400;
  margin: 0 0 30px;
}
.nowplaying {
  font-size: 120px;
  line-height: 1;
  color: #eee;
  text-shadow: 0 0 5rem #028ae9;
  transition: all 0.07s ease;
  min-height: 120px;
}
.keys {
  display: block;
  width: 100%;
  height: 350px;
  max-width: 880px;
  position: relative;
  margin: 40px auto 0;
  cursor: none;
}
.key {
  position: relative;
  border: 4px solid black;
  border-radius: 0.5rem;
  transition: all 0.07s ease;
  display: block;
  box-sizing: border-box;
  z-index: 2;
}
.key:not(.sharp) {
  float: left;
  width: 10%;
  height: 100%;
  background: rgba(255, 255, 255, 0.8);
}
.key.sharp {
  position: absolute;
  width: 6%;
  height: 60%;
  background: #000;
  color: #eee;
  top: 0;
  z-index: 3;
}

.key[data-key="87"] {
  left: 7%;
}

.key[data-key="69"] {
  left: 17%;
}

.key[data-key="84"] {
  left: 37%;
}

.key[data-key="89"] {
  left: 47%;
}

.key[data-key="85"] {
  left: 57%;
}

.key[data-key="79"] {
  left: 77%;
}

.key[data-key="80"] {
  left: 87%;
}

.playing {
  transform: scale(0.95);
  border-color: #028ae9;
  box-shadow: 0 0 1rem #028ae9;
}

.hints {
  display: block;
  width: 100%;
  opacity: 0;
  position: absolute;
  bottom: 7px;
  transition: opacity 0.3s ease-out;
  font-size: 20px;
}

.keys:hover .hints {
  opacity: 1;
}
</style>
